Package com.sas.metadata.remote

# Interface Property

All Superinterfaces:
  `AbstractProperty`, `CMetadata`, `LocalizedType`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface Property extends AbstractProperty
A parameter, option or other type of information that is used to tailor a metadata object.

Attributes of Property are:

- `DefaultValue`
- `PropertyRole`
- `PropertyName`
- `Delimiter`
- `UseValueOnly`
- `SQLType`

Associations of Property are:

- `AssociatedLocalizedObject`
- `AssociatedObject`
- `OwningType`
- `AssociatedPropertySet`

## Usage

To create an instance of this Property, use the `factory` create methods.
Example: create a Property with name "Property_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Property myObject = (Property) factory.createComplexMetadataObject(objectStore, "Property_Object", MetadataObjects.PROPERTY, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDLOCALIZEDOBJECT_NAME`
  Constant used for the name of the AssociatedLocalizedObject association.
  `static final String`
  `ASSOCIATION_ASSOCIATEDOBJECT_NAME`
  Constant used for the name of the AssociatedObject association.
  `static final String`
  `ASSOCIATION_ASSOCIATEDPROPERTYSET_NAME`
  Constant used for the name of the AssociatedPropertySet association.
  `static final String`
  `ASSOCIATION_OWNINGTYPE_NAME`
  Constant used for the name of the OwningType association.
  `static final String`
  `ATTRIBUTE_DEFAULTVALUE_NAME`
  Constant used for the name of the DefaultValue attribute.
  `static final String`
  `ATTRIBUTE_DELIMITER_NAME`
  Constant used for the name of the Delimiter attribute.
  `static final String`
  `ATTRIBUTE_PROPERTYNAME_NAME`
  Constant used for the name of the PropertyName attribute.
  `static final String`
  `ATTRIBUTE_PROPERTYROLE_NAME`
  Constant used for the name of the PropertyRole attribute.
  `static final String`
  `ATTRIBUTE_SQLTYPE_NAME`
  Constant used for the name of the SQLType attribute.
  `static final String`
  `ATTRIBUTE_USEVALUEONLY_NAME`
  Constant used for the name of the UseValueOnly attribute.

  ### Fields inherited from interface com.sas.metadata.remote.AbstractProperty

  `ASSOCIATION_ASSOCIATEDPROPERTYGROUP_NAME, ASSOCIATION_CUSTOMIZERS_NAME, ASSOCIATION_EDITORS_NAME, ASSOCIATION_STOREDCONFIGURATION_NAME, ASSOCIATION_VALIDATORS_NAME, ATTRIBUTE_ISEXPERT_NAME, ATTRIBUTE_ISLINKED_NAME, ATTRIBUTE_ISREQUIRED_NAME, ATTRIBUTE_ISUPDATEABLE_NAME, ATTRIBUTE_ISVISIBLE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.LocalizedType

  `ASSOCIATION_RESOURCES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Root`
  `getAssociatedLocalizedObject()`
  Gets the `Root` for `AssociatedLocalizedObject`
  `AssociationList`
  `getAssociatedLocalizedObjects()`
  Gets the AssociationList of `AssociatedLocalizedObjects`
  `AssociationList`
  `getAssociatedLocalizedObjects(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedLocalizedObjects`
  `Root`
  `getAssociatedObject()`
  Gets the `Root` for `AssociatedObject`
  `AssociationList`
  `getAssociatedObjects()`
  Gets the AssociationList of `AssociatedObjects`
  `AssociationList`
  `getAssociatedObjects(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedObjects`
  `PropertySet`
  `getAssociatedPropertySet()`
  Gets the `PropertySet` for `AssociatedPropertySet`
  `AssociationList`
  `getAssociatedPropertySets()`
  Gets the Association list of `AssociatedPropertySets`
  `AssociationList`
  `getAssociatedPropertySets(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedPropertySets`
  `String`
  `getDefaultValue()`
  Gets the `String` value of `DefaultValue`
  `int`
  `getDefaultValueMaxLength()`
  Gets the maximum length of `DefaultValue`
  `int`
  `getDefaultValueState()`
  Gets the Metadata State of `DefaultValue`
  `String`
  `getDelimiter()`
  Gets the `String` value of `Delimiter`
  `int`
  `getDelimiterMaxLength()`
  Gets the maximum length of `Delimiter`
  `int`
  `getDelimiterState()`
  Gets the Metadata State of `Delimiter`
  `PropertyType`
  `getOwningType()`
  Gets the `PropertyType` for `OwningType`
  `AssociationList`
  `getOwningTypes()`
  Gets the AssociationList of `OwningTypes`
  `AssociationList`
  `getOwningTypes(boolean fGoToServer)`
  Gets the Associationlist of `OwningTypes`
  `String`
  `getPropertyName()`
  Gets the `String` value of `PropertyName`
  `int`
  `getPropertyNameMaxLength()`
  Gets the maximum length of `PropertyName`
  `int`
  `getPropertyNameState()`
  Gets the Metadata State of `PropertyName`
  `String`
  `getPropertyRole()`
  Gets the `String` value of `PropertyRole`
  `int`
  `getPropertyRoleMaxLength()`
  Gets the maximum length of `PropertyRole`
  `int`
  `getPropertyRoleState()`
  Gets the Metadata State of `PropertyRole`
  `int`
  `getSQLType()`
  Gets the `int` value of `SQLType`
  `int`
  `getSQLTypeState()`
  Gets the Metadata State of `SQLType`
  `int`
  `getUseValueOnly()`
  Gets the `int` value of `UseValueOnly`
  `int`
  `getUseValueOnlyState()`
  Gets the Metadata State of `UseValueOnly`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `AssociatedLocalizedObject`
  `AssociatedObject`
  `OwningType`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedLocalizedObject(Root inObject)`
  Sets the `AssociatedLocalizedObjects` list 0th element to be `inObject`.
  `void`
  `setAssociatedLocalizedObjects(AssociationList list)`
  Sets the `AssociatedLocalizedObjects` list to be `list`.
  `void`
  `setAssociatedLocalizedObjects(AssociationList list, int state)`
  Sets the `AssociatedLocalizedObjects` list to be `list`.
  `void`
  `setAssociatedObject(Root inObject)`
  Sets the `AssociatedObjects` list 0th element to be `inObject`.
  `void`
  `setAssociatedObjects(AssociationList list)`
  Sets the `AssociatedObjects` list to be `list`.
  `void`
  `setAssociatedObjects(AssociationList list, int state)`
  Sets the `AssociatedObjects` list to be `list`.
  `void`
  `setAssociatedPropertySet(PropertySet inObject)`
  Sets the `AssociatedPropertySets` list 0th element to be `inObject`.
  `void`
  `setAssociatedPropertySets(AssociationList list)`
  Sets the `AssociatedPropertySets` list to be `list`.
  `void`
  `setAssociatedPropertySets(AssociationList list, int state)`
  Sets the `AssociatedPropertySets` list to be `list`.
  `void`
  `setDefaultValue(String inDefaultValue)`
  Sets the `DefaultValue` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDefaultValue(String inDefaultValue, int state)`
  Sets the `DefaultValue` Metadata State.
  `void`
  `setDefaultValueState(int state)`
  Sets the Metadata State of `DefaultValue`.
  `void`
  `setDelimiter(String inDelimiter)`
  Sets the `Delimiter` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDelimiter(String inDelimiter, int state)`
  Sets the `Delimiter` Metadata State.
  `void`
  `setDelimiterState(int state)`
  Sets the Metadata State of `Delimiter`.
  `void`
  `setOwningType(PropertyType inObject)`
  Sets the `OwningTypes` list 0th element to be `inObject`.
  `void`
  `setOwningTypes(AssociationList list)`
  Sets the `OwningTypes` list to be `list`.
  `void`
  `setOwningTypes(AssociationList list, int state)`
  Sets the `OwningTypes` list to be `list`.
  `void`
  `setPropertyName(String inPropertyName)`
  Sets the `PropertyName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPropertyName(String inPropertyName, int state)`
  Sets the `PropertyName` Metadata State.
  `void`
  `setPropertyNameState(int state)`
  Sets the Metadata State of `PropertyName`.
  `void`
  `setPropertyRole(String inPropertyRole)`
  Sets the `PropertyRole` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPropertyRole(String inPropertyRole, int state)`
  Sets the `PropertyRole` Metadata State.
  `void`
  `setPropertyRoleState(int state)`
  Sets the Metadata State of `PropertyRole`.
  `void`
  `setSQLType(int inSQLType)`
  Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSQLType(int inSQLType, int state)`
  Sets the `SQLType` Metadata State.
  `void`
  `setSQLType(String inSQLType)`
  Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSQLType(String inSQLType, int state)`
  Sets the `SQLType` value and Metadata State.
  `void`
  `setSQLTypeState(int state)`
  Sets the Metadata State of `SQLType`.
  `void`
  `setUseValueOnly(int inUseValueOnly)`
  Sets the `UseValueOnly` value and sets the state to MetadataState.LOCAL.
  `void`
  `setUseValueOnly(int inUseValueOnly, int state)`
  Sets the `UseValueOnly` Metadata State.
  `void`
  `setUseValueOnly(String inUseValueOnly)`
  Sets the `UseValueOnly` value and sets the state to MetadataState.LOCAL.
  `void`
  `setUseValueOnly(String inUseValueOnly, int state)`
  Sets the `UseValueOnly` value and Metadata State.
  `void`
  `setUseValueOnlyState(int state)`
  Sets the Metadata State of `UseValueOnly`.

  ### Methods inherited from interface com.sas.metadata.remote.AbstractProperty

  `getAssociatedPropertyGroup, getAssociatedPropertyGroups, getAssociatedPropertyGroups, getCustomizers, getCustomizers, getEditors, getEditors, getIsExpert, getIsExpertState, getIsLinked, getIsLinkedState, getIsRequired, getIsRequiredState, getIsUpdateable, getIsUpdateableState, getIsVisible, getIsVisibleState, getStoredConfiguration, getStoredConfigurations, getStoredConfigurations, getValidators, getValidators, setAssociatedPropertyGroup, setAssociatedPropertyGroups, setAssociatedPropertyGroups, setCustomizers, setCustomizers, setEditors, setEditors, setIsExpert, setIsExpert, setIsExpert, setIsExpert, setIsExpertState, setIsLinked, setIsLinked, setIsLinked, setIsLinked, setIsLinkedState, setIsRequired, setIsRequired, setIsRequired, setIsRequired, setIsRequiredState, setIsUpdateable, setIsUpdateable, setIsUpdateable, setIsUpdateable, setIsUpdateableState, setIsVisible, setIsVisible, setIsVisible, setIsVisible, setIsVisibleState, setStoredConfiguration, setStoredConfigurations, setStoredConfigurations, setValidators, setValidators`

  ### Methods inherited from interface com.sas.metadata.remote.LocalizedType

  `getResources, getResources, setResources, setResources`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_DEFAULTVALUE_NAME

    static final String ATTRIBUTE_DEFAULTVALUE_NAME
    Constant used for the name of the DefaultValue attribute.

    DefaultValue: The default value for this parameter.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PROPERTYROLE_NAME

    static final String ATTRIBUTE_PROPERTYROLE_NAME
    Constant used for the name of the PropertyRole attribute.

    PropertyRole: The role of this property (load, access, initialization, etc).

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PROPERTYNAME_NAME

    static final String ATTRIBUTE_PROPERTYNAME_NAME
    Constant used for the name of the PropertyName attribute.

    PropertyName: This attribute is the name used by the software program, for example the name of a macro variable. This object also has a 'Name' attribute that is the display name or label.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_DELIMITER_NAME

    static final String ATTRIBUTE_DELIMITER_NAME
    Constant used for the name of the Delimiter attribute.

    Delimiter: This is the delimiter that is used between the PropertyName and Default value. It may be a space, an equals sign, or any other appropriate delimiter.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_USEVALUEONLY_NAME

    static final String ATTRIBUTE_USEVALUEONLY_NAME
    Constant used for the name of the UseValueOnly attribute.

    UseValueOnly: This means that only the string in the Default value is used. This attribute is true, for example, for the SAS system option CAPS and NOCAPS. The PropertyName is 'CAPS', but the value may be CAPS or NOCAPS.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_SQLTYPE_NAME

    static final String ATTRIBUTE_SQLTYPE_NAME
    Constant used for the name of the SQLType attribute.

    SQLType: This is an integer value that identifies the SQL type of the data. If other, 1111, or array, 2003, is specified the client will need to look to the associated owning type for more information. If there is no associated owning type or the owning type indicates a value of other it is up to the client to determine how to handle the value. The default value will be string, 12.

  - ARRAY = 2003
  - BIGINT = -5
  - BINARY = -2
  - BIT = -7
  - BLOB = 2004
  - CHAR = 1
  - CLOB = 2005
  - DATE = 91
  - DECIMAL = 3
  - DISTINCT = 2001
  - DOUBLE = 8
  - FLOAT = 6
  - INTEGER = 4
  - JAVA_OBJECT = 2000
  - LONGVARBINARY = -4
  - LONGVARCHAR = -1
  - NULL = 0
  - NUMERIC = 2
  - OTHER = 1111
  - REAL = 7
  - REF = 2006
  - SMALLINT = 5
  - STRUCT = 2002
  - TIME = 92
  - TIMESTAMP = 93
  - TINYINT = -6
  - VARBINARY = -3
  - VARCHAR = 12
  - QuotedString = 2200

See Also:
  - Constant Field Values

- ### ASSOCIATION_ASSOCIATEDLOCALIZEDOBJECT_NAME

  static final String ASSOCIATION_ASSOCIATEDLOCALIZEDOBJECT_NAME
  Constant used for the name of the AssociatedLocalizedObject association.

  AssociatedLocalizedObject: The object with a localized attribute.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_ASSOCIATEDOBJECT_NAME

  static final String ASSOCIATION_ASSOCIATEDOBJECT_NAME
  Constant used for the name of the AssociatedObject association.

  AssociatedObject: The object described by these properties.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_OWNINGTYPE_NAME

  static final String ASSOCIATION_OWNINGTYPE_NAME
  Constant used for the name of the OwningType association.

  OwningType: The data type of this property.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_ASSOCIATEDPROPERTYSET_NAME

  static final String ASSOCIATION_ASSOCIATEDPROPERTYSET_NAME
  Constant used for the name of the AssociatedPropertySet association.

  AssociatedPropertySet: The property set this property belongs to.

  See Also:
    - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `AbstractProperty`
    Specified by:
      `initializeRequiredObjects` in interface `LocalizedType`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `AssociatedLocalizedObject`
    `AssociatedObject`
    `OwningType`
    Specified by:
      `initializePredObjects` in interface `AbstractProperty`
    Specified by:
      `initializePredObjects` in interface `LocalizedType`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultValue

    String getDefaultValue() throws RemoteException
    Gets the `String` value of `DefaultValue`
    Returns:
      The `DefaultValue`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultValueState

    int getDefaultValueState() throws RemoteException
    Gets the Metadata State of `DefaultValue`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultValueMaxLength

    int getDefaultValueMaxLength() throws RemoteException
    Gets the maximum length of `DefaultValue`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertyRole

    String getPropertyRole() throws RemoteException
    Gets the `String` value of `PropertyRole`
    Returns:
      The `PropertyRole`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertyRoleState

    int getPropertyRoleState() throws RemoteException
    Gets the Metadata State of `PropertyRole`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertyRoleMaxLength

    int getPropertyRoleMaxLength() throws RemoteException
    Gets the maximum length of `PropertyRole`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertyName

    String getPropertyName() throws RemoteException
    Gets the `String` value of `PropertyName`
    Returns:
      The `PropertyName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertyNameState

    int getPropertyNameState() throws RemoteException
    Gets the Metadata State of `PropertyName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertyNameMaxLength

    int getPropertyNameMaxLength() throws RemoteException
    Gets the maximum length of `PropertyName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDelimiter

    String getDelimiter() throws RemoteException
    Gets the `String` value of `Delimiter`
    Returns:
      The `Delimiter`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDelimiterState

    int getDelimiterState() throws RemoteException
    Gets the Metadata State of `Delimiter`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDelimiterMaxLength

    int getDelimiterMaxLength() throws RemoteException
    Gets the maximum length of `Delimiter`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUseValueOnly

    int getUseValueOnly() throws RemoteException
    Gets the `int` value of `UseValueOnly`
    Returns:
      The `UseValueOnly`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUseValueOnlyState

    int getUseValueOnlyState() throws RemoteException
    Gets the Metadata State of `UseValueOnly`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSQLType

    int getSQLType() throws RemoteException
    Gets the `int` value of `SQLType`
    Returns:
      The `SQLType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSQLTypeState

    int getSQLTypeState() throws RemoteException
    Gets the Metadata State of `SQLType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedLocalizedObjects

    AssociationList getAssociatedLocalizedObjects() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedLocalizedObjects`
    Returns:
      Returns the AssociationList of `AssociatedLocalizedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedLocalizedObject

    Root getAssociatedLocalizedObject() throws RemoteException, MdException
    Gets the `Root` for `AssociatedLocalizedObject`
    Returns:
      The `Root` ( `null` if not set) of `AssociatedLocalizedObject`which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedObjects`
    Returns:
      Returns the AssociationList of `AssociatedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedObject

    Root getAssociatedObject() throws RemoteException, MdException
    Gets the `Root` for `AssociatedObject`
    Returns:
      The `Root` ( `null` if not set) of `AssociatedObject`which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningTypes

    AssociationList getOwningTypes() throws RemoteException, MdException
    Gets the AssociationList of `OwningTypes`
    Returns:
      Returns the AssociationList of `OwningTypes` which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getOwningType

    PropertyType getOwningType() throws RemoteException, MdException
    Gets the `PropertyType` for `OwningType`
    Returns:
      The `PropertyType` ( `null` if not set) of `OwningType`which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedPropertySets

    AssociationList getAssociatedPropertySets() throws RemoteException, MdException
    Gets the Association list of `AssociatedPropertySets`
    Returns:
      The AssociationList of `AssociatedPropertySets` which can be of type:
      PropertySet
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedPropertySet

    PropertySet getAssociatedPropertySet() throws RemoteException, MdException
    Gets the `PropertySet` for `AssociatedPropertySet`
    Returns:
      The `PropertySet` ( `null` if not set ) of `AssociatedPropertySet` which can be of type:
      PropertySet
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedLocalizedObjects

    AssociationList getAssociatedLocalizedObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedLocalizedObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedLocalizedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningTypes

    AssociationList getOwningTypes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningTypes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `OwningTypes` which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedPropertySets

    AssociationList getAssociatedPropertySets(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedPropertySets`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedPropertySets` which can be of type:
      PropertySet
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setDefaultValue

    void setDefaultValue(String inDefaultValue) throws RemoteException
    Sets the `DefaultValue` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDefaultValue` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultValue

    void setDefaultValue(String inDefaultValue, int state) throws RemoteException
    Sets the `DefaultValue` Metadata State.
    Parameters:
      `inDefaultValue` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultValueState

    void setDefaultValueState(int state) throws RemoteException
    Sets the Metadata State of `DefaultValue`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertyRole

    void setPropertyRole(String inPropertyRole) throws RemoteException
    Sets the `PropertyRole` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPropertyRole` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertyRole

    void setPropertyRole(String inPropertyRole, int state) throws RemoteException
    Sets the `PropertyRole` Metadata State.
    Parameters:
      `inPropertyRole` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertyRoleState

    void setPropertyRoleState(int state) throws RemoteException
    Sets the Metadata State of `PropertyRole`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertyName

    void setPropertyName(String inPropertyName) throws RemoteException
    Sets the `PropertyName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPropertyName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertyName

    void setPropertyName(String inPropertyName, int state) throws RemoteException
    Sets the `PropertyName` Metadata State.
    Parameters:
      `inPropertyName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertyNameState

    void setPropertyNameState(int state) throws RemoteException
    Sets the Metadata State of `PropertyName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDelimiter

    void setDelimiter(String inDelimiter) throws RemoteException
    Sets the `Delimiter` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDelimiter` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDelimiter

    void setDelimiter(String inDelimiter, int state) throws RemoteException
    Sets the `Delimiter` Metadata State.
    Parameters:
      `inDelimiter` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDelimiterState

    void setDelimiterState(int state) throws RemoteException
    Sets the Metadata State of `Delimiter`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUseValueOnly

    void setUseValueOnly(int inUseValueOnly) throws RemoteException
    Sets the `UseValueOnly` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inUseValueOnly` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUseValueOnly

    void setUseValueOnly(int inUseValueOnly, int state) throws RemoteException
    Sets the `UseValueOnly` Metadata State.
    Parameters:
      `inUseValueOnly` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUseValueOnly

    void setUseValueOnly(String inUseValueOnly) throws RemoteException
    Sets the `UseValueOnly` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inUseValueOnly` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUseValueOnly

    void setUseValueOnly(String inUseValueOnly, int state) throws RemoteException
    Sets the `UseValueOnly` value and Metadata State.
    Parameters:
      `inUseValueOnly` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUseValueOnlyState

    void setUseValueOnlyState(int state) throws RemoteException
    Sets the Metadata State of `UseValueOnly`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLType

    void setSQLType(int inSQLType) throws RemoteException
    Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSQLType` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLType

    void setSQLType(int inSQLType, int state) throws RemoteException
    Sets the `SQLType` Metadata State.
    Parameters:
      `inSQLType` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLType

    void setSQLType(String inSQLType) throws RemoteException
    Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSQLType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLType

    void setSQLType(String inSQLType, int state) throws RemoteException
    Sets the `SQLType` value and Metadata State.
    Parameters:
      `inSQLType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLTypeState

    void setSQLTypeState(int state) throws RemoteException
    Sets the Metadata State of `SQLType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedLocalizedObjects

    void setAssociatedLocalizedObjects(AssociationList list) throws RemoteException
    Sets the `AssociatedLocalizedObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedLocalizedObjects

    void setAssociatedLocalizedObjects(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedLocalizedObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedLocalizedObject

    void setAssociatedLocalizedObject(Root inObject) throws RemoteException
    Sets the `AssociatedLocalizedObjects` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Root
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObjects

    void setAssociatedObjects(AssociationList list) throws RemoteException
    Sets the `AssociatedObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObjects

    void setAssociatedObjects(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObject

    void setAssociatedObject(Root inObject) throws RemoteException
    Sets the `AssociatedObjects` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Root
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningTypes

    void setOwningTypes(AssociationList list) throws RemoteException
    Sets the `OwningTypes` list to be `list`. Object of which can be of type:
    PropertyType
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningTypes

    void setOwningTypes(AssociationList list, int state) throws RemoteException
    Sets the `OwningTypes` list to be `list`. Object of which can be of type:
    PropertyType
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningType

    void setOwningType(PropertyType inObject) throws RemoteException
    Sets the `OwningTypes` list 0th element to be `inObject`.
    Parameters:
      `inObject` - PropertyType
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedPropertySets

    void setAssociatedPropertySets(AssociationList list) throws RemoteException
    Sets the `AssociatedPropertySets` list to be `list`. Objects of which can be of type:
    PropertySet
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedPropertySets

    void setAssociatedPropertySets(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedPropertySets` list to be `list`. Objects of which can be of type:
    PropertySet
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedPropertySet

    void setAssociatedPropertySet(PropertySet inObject) throws RemoteException
    Sets the `AssociatedPropertySets` list 0th element to be `inObject`.
    Parameters:
      `inObject` - PropertySet
    Throws:
      `RemoteException` - If error communicating with remote object.